//+------------------------------------------------------------------+
//|                                                     bobnaley.mq5 |
//|                                             Copyright 2010, AM2. |
//|                                   http://www.crossmaker.narod.ru |
//+------------------------------------------------------------------+

#property copyright "Copyright 2010, AM2."
#property link      "http://www.crossmaker.narod.ru"
#property version   "1.12"

#include <Trade\Trade.mqh>            

//---  
input double TakeProfit    =   0.007; // Take Profit
input double StopLoss      =   0.0035;// Stop Loss
input int MA_Period        =      76; //  Moving Average
input int Stoch_OverSold   =      30; //   Stochastic
input int Stoch_OverBought =      70; //   Stochastic
input double Lot           =       5; //     
 
//---  
int maHandle;                         //   Moving Average
int stochHandle;                      //   Stochastic
double maVal[3];                      //       Moving Average
double stochVal[3];                   //       Stochastic  
CTrade trade;                         //   CTrade
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   Moving Average
   maHandle=iMA(NULL,0,MA_Period,0,MODE_SMA,PRICE_CLOSE);
//---    Stochastic
   stochHandle=iStochastic(NULL,0,5,3,3,MODE_EMA,STO_CLOSECLOSE);
   
//---  ,      Invalid Handle
   if(maHandle<0 || stochHandle<0)
     {
      Alert("    -  : ",GetLastError(),"!!");
      return(-1);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---   
//   IndicatorRelease(maHandle);
//   IndicatorRelease(stochHandle); 
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {

//---          
   int Mybars=Bars(_Symbol,_Period);
   if(Mybars<100) //      100
     {
      Alert("   100 ,    !!!");
      return;
     }  
//---      

   if(CopyBuffer(maHandle,0,0,3,maVal)<0 || CopyBuffer(stochHandle,0,0,3,stochVal)<0)
     {
      Alert("    -  :",GetLastError());
      return;
     }
 
   double Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK); //    
   double Bid = SymbolInfoDouble(_Symbol,SYMBOL_BID); //    
       
/*
    1.     : MA , 
       Stochastic     
*/

//---    boolean,        
   bool BuyCondition =(maVal[0]<maVal[1] && maVal[1]<maVal[2] && Ask > maVal[0]&&  // MA     
                        stochVal[1]>stochVal[2] && stochVal[0]<Stoch_OverSold);    // Stochastic             
                                     
//---   
   if(BuyCondition)                                          //   
     if(!PositionSelect(_Symbol))                            //       
        if(AccountInfoDouble(ACCOUNT_FREEMARGIN)>5000)       //       
          {  
           trade.PositionOpen(_Symbol,
           ORDER_TYPE_BUY,                                   //   
           Money_M(),                                        //    
           Ask,                                              //   ask 
           Ask - StopLoss,                                   // Stop Loss
           Ask + TakeProfit,                                 // Take Profit 
           " ");                                             //  
          }  
/*
    2.     : MA , 
       Stochastic     
*/

//---    boolean,        
   bool SellCondition = (maVal[0]>maVal[1]) && (maVal[1]>maVal[2]&& Bid < maVal[0]&&  // MA     
                          stochVal[1]<stochVal[2] && stochVal[0]>Stoch_OverBought);   // Stochastic     
                         
//---   
   if(SellCondition)                                         //   
     if(!PositionSelect(_Symbol))                            //    
        if(AccountInfoDouble(ACCOUNT_FREEMARGIN)>5000)       //           
          {   
           trade.PositionOpen(_Symbol,                       // 
           ORDER_TYPE_SELL,                                  //    
           Money_M(),                                        //    
           Bid,                                              //   bid
           Bid + StopLoss,                                   // Stop Loss
           Bid - TakeProfit,                                 // Take Profit 
           " ");                                             //            
          }
   return;
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
double Money_M()
{
   double Lots=AccountInfoDouble(ACCOUNT_FREEMARGIN)/100000*50;
   Lots=MathMin(15,MathMax(0.1,Lots));
   if(Lots<0.1) 
     Lots=NormalizeDouble(Lots,2);
   else
     {
     if(Lots<1) Lots=NormalizeDouble(Lots,1);
     else       Lots=NormalizeDouble(Lots,0);
     }
    return(Lots);   
}
//+------------------------------------------------------------------+

